<?php
/**************************************************
  Coppermine 1.5.x Plugin - Windows Media Player
  *************************************************
  Copyright (c) 2010 BCTechWorks
  ********************************************
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/branches/cpg1.5.x/plugins/windows_media_player/codebase.php $
  $Revision: 1.1 $
  $LastChangedBy: bjcworks $
  $Date: 2011-02-23 $
**************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$thisplugin->add_action('plugin_install', 'wmp_install');
$thisplugin->add_action('plugin_uninstall', 'wmp_uninstall');
$thisplugin->add_action('plugin_cleanup', 'wmp_cleanup');

$thisplugin->add_filter('html_other_media','wmp_other_media');
$thisplugin->add_action('page_start','wmp_page_start');

if ($CONFIG['thumbnail_to_fullsize'] == 1) {
    $thisplugin->add_filter('fullsize_html','wmp_fullsize');
    $thisplugin->add_filter('theme_display_thumbnails_params','wmp_fullsize_thumbnail_params');
}


function wmp_get_html($CURRENT_PIC_DATA, $check_only = false) {

    if (in_array($CURRENT_PIC_DATA['extension'], array('wmv', 'wma'))) {
        if ($check_only == true) {
            return true;
        }

        global $CONFIG, $USER;
        $thumb = get_pic_url($CURRENT_PIC_DATA, 'thumb');
        $file = $CONFIG['ecards_more_pic_target'].get_pic_url($CURRENT_PIC_DATA, 'fullsize');
				$pwidth = $CURRENT_PIC_DATA['pwidth'];
				$pheight = $CURRENT_PIC_DATA['pheight'];
				
        $autostart = $CONFIG['media_autostart'] == 1 ? "1" : "0";

        $theme = $USER['theme'] ? $USER['theme'] : $CONFIG['theme'];
        $stylesheet = file_get_contents("themes/{$theme}/style.css");
        preg_match_all('/\.tableh2.*{(.*)}/Us', $stylesheet, $matches);
        $style = array();
        foreach($matches[1] as $value) {
            $split = explode(";", $value);
            foreach($split as $value2) {
                $split2 = explode(":", $value2);
                if (isset($split2[0]) && isset($split2[1])) {
                    $style[trim($split2[0])] = trim($split2[1]);
                }
            }
        }
/*	
				$JS['includes'] = 'plugins/windows_media_player/silverlight.js';
				CPGPluginAPI::filter('javascript_includes',$JS['includes']);
				$JS['includes'] = 'plugins/windows_media_player/wmvplayer.js';
				CPGPluginAPI::filter('javascript_includes',$JS['includes']);
*/								
				$pic_html = <<< EOT
				<script type="text/javascript" src="plugins/windows_media_player/silverlight.js"></script>
				<script type="text/javascript" src="plugins/windows_media_player/wmvplayer.js"></script>
				<div id="myplayer">the player will be placed here</div>
				<script type="text/javascript">
					var elm = document.getElementById("myplayer");
					var src = 'plugins/windows_media_player/wmvplayer.xaml';
					var cfg = {
						file:'$file',
						width:'$pwidth',
						height:'$pheight'
					};
					var ply = new jeroenwijering.Player(elm,src,cfg);
				</script>
EOT;

        return $pic_html;
    } else {
        return false;
    }
}


function wmp_other_media($pic_html) {
    global $CURRENT_PIC_DATA;
		
    if (wmp_get_html($CURRENT_PIC_DATA, true)) {
			$pic_html = wmp_get_html($CURRENT_PIC_DATA);
    }
    return $pic_html;
}


function wmp_fullsize($html) {
    global $CONFIG, $FORBIDDEN_SET, $pid;

    $sql = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p WHERE pid='$pid' $FORBIDDEN_SET";
    $result = cpg_db_query($sql);
    if (!mysql_num_rows($result)) {
        cpg_die(ERROR, $lang_errors['non_exist_ap'], __FILE__, __LINE__);
    }
    $CURRENT_PIC_DATA = mysql_fetch_assoc($result);

    $mime_content = cpg_get_type($CURRENT_PIC_DATA['filename']);
    $CURRENT_PIC_DATA['extension'] = $mime_content['extension'];

    if ($CURRENT_PIC_DATA['pwidth']==0 || $CURRENT_PIC_DATA['pheight']==0) {
        $resize_method = $CONFIG['picture_use'] == "thumb" ? ($CONFIG['thumb_use'] == "ex" ? "any" : $CONFIG['thumb_use']) : $CONFIG['picture_use'];
        if ($resize_method == 'ht') {
            $pwidth = $CONFIG['picture_width']*4/3;
            $pheight = $CONFIG['picture_width'];
        } else { 
            $pwidth = $CONFIG['picture_width'];
            $pheight = $CONFIG['picture_width']*3/4;
        }

        $CURRENT_PIC_DATA['pwidth']  = $pwidth; // Default width

        // Set default height; if file is a movie
        if ($mime_content['content']=='movie') {
            $CURRENT_PIC_DATA['pheight'] = $pheight; // Default height
        }
    }

    if ($pic_html = wmp_get_html($CURRENT_PIC_DATA)) {
        $html = preg_replace('/<body style="margin:0px; padding:0px; background-color: gray;">(.*)<\/body>/Usi', '<body style="margin:0px; padding:0px; background-color: gray;">'.$pic_html.'</body>', $html);
    }

    return $html;
}


function wmp_fullsize_thumbnail_params($data) {
    preg_match('/alt="(.*)"/Ui', $data['{THUMB}'], $match_alt);
    $mime_content = cpg_get_type($match_alt[1]);

    if (wmp_get_html($mime_content, true)) {
        global $CONFIG;

        preg_match('/pid=([0-9]+)/i', $data['{LINK_TGT}'], $match_pid);
        $pid = $match_pid[1];

        $sql = "SELECT pwidth, pheight FROM {$CONFIG['TABLE_PICTURES']} WHERE pid='$pid'";
        $result = cpg_db_query($sql);
        $CURRENT_PIC_DATA = mysql_fetch_assoc($result);

        if ($CURRENT_PIC_DATA['pwidth']==0 || $CURRENT_PIC_DATA['pheight']==0) {
            $resize_method = $CONFIG['picture_use'] == "thumb" ? ($CONFIG['thumb_use'] == "ex" ? "any" : $CONFIG['thumb_use']) : $CONFIG['picture_use'];
            if ($resize_method == 'ht') {
                $pwidth = $CONFIG['picture_width']*4/3;
                $pheight = $CONFIG['picture_width'];
            } else { 
                $pwidth = $CONFIG['picture_width'];
                $pheight = $CONFIG['picture_width']*3/4;
            }

            $CURRENT_PIC_DATA['pwidth']  = $pwidth; // Default width

            // Set default height; if file is a movie
            if ($mime_content['content']=='movie') {
                $CURRENT_PIC_DATA['pheight'] = $pheight; // Default height
            }
        }

        $new_height = ceil($CURRENT_PIC_DATA['pheight'] + $CONFIG['fullsize_padding_y'] + 24);
        $new_width = ceil($CURRENT_PIC_DATA['pwidth'] + $CONFIG['fullsize_padding_x']);

        $data['{LINK_TGT}'] = preg_replace('/width=([0-9]+),height=([0-9]+)/i', 'width='.$new_width.',height='.$new_height, $data['{LINK_TGT}']);
    }

    return $data;
}


function wmp_update_filetype($extension, $type) {
    global $CONFIG;
    if (!mysql_result(cpg_db_query("SELECT COUNT(*) FROM {$CONFIG['TABLE_FILETYPES']} WHERE extension = '$extension'"), 0)) {
        cpg_db_query("INSERT INTO {$CONFIG['TABLE_FILETYPES']} (extension,mime,content,player) VALUES ('$extension', 'video/wmv', '$type', 'WMP')");
    } else {
        cpg_db_query("UPDATE {$CONFIG['TABLE_FILETYPES']} SET mime = 'video/wmv', player = 'WMP' WHERE extension = '$extension'");
    }

    if ($type == "movie") {
        $config_value = "allowed_mov_types";
    } elseif ($type == "audio") {
        $config_value = "allowed_snd_types";
    }
    if (strpos($CONFIG[$config_value], $extension) === FALSE) {
        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = CONCAT(value, '/$extension') WHERE name = '$config_value'");
    }
    return;
}


function wmp_reset_filetype($extension, $mime) {
    global $CONFIG;
    if (substr_count($mime, 'video') > 0) {
        $config_value = "allowed_mov_types";
    } elseif (substr_count($mime, 'audio') > 0) {
        $config_value = "allowed_snd_types";
    }
    $CONFIG[$config_value] = str_replace('/'.$extension, '', $CONFIG[$config_value]);
    $CONFIG[$config_value] = str_replace($extension.'/', '', $CONFIG[$config_value]);
    $CONFIG[$config_value] = str_replace($extension, '', $CONFIG[$config_value]);
    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = '{$CONFIG[$config_value]}' WHERE name = '$config_value'");
    cpg_db_query("UPDATE {$CONFIG['TABLE_FILETYPES']} SET mime = '$mime', player = 'WMP' WHERE extension = '$extension'");
}

function wmp_install() {
    wmp_update_filetype('wmv', 'movie');
    wmp_update_filetype('wma', 'audio');
    return true;
}


function wmp_uninstall() {
    $superCage = Inspekt::makeSuperCage();

    if (!$superCage->post->keyExists('drop')) {
        return 1;
    }

    if (!checkFormToken()) {
        global $lang_errors;
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }

    if ($superCage->post->getInt('drop') == 1) {
        fmp_reset_filetype('wmv', 'video/wmv');
        fmp_reset_filetype('wma', 'audio/wma');
        return true;
    }
}


function wmp_cleanup($action) {
    $superCage = Inspekt::makeSuperCage();
    $cleanup = $superCage->server->getEscaped('REQUEST_URI');
    if ($action == 1) {
        global $CONFIG, $lang_common;

        require_once "./plugins/windows_media_player/lang/english.php";
        if ($CONFIG['lang'] != 'english' && file_exists("./plugins/windows_media_player/lang/{$CONFIG['lang']}.php")) {
            require_once "./plugins/windows_media_player/lang/{$CONFIG['lang']}.php";
        }

        list($timestamp, $form_token) = getFormToken();
        $button_array = array('cancel' => cpg_fetch_icon('leftleft', 2), 'continue' => cpg_fetch_icon('rightright', 2));
        echo <<< EOT
            <table border="0" cellspacing="0" cellpadding="0">
                <tr>
                    <td class="tableb">
                        {$lang_plugin_windows_media_player['uninstall_info']}!
                    </td>
                    <td class="tableb">
                        <form action="pluginmgr.php" method="post">
                            <button type="submit" class="button" name="cancel" value="{$lang_common['back']}">{$button_array['cancel']}{$lang_common['back']}</button>
                        </form>
                    </td>
                    <td class="tableb">
                        <form action="{$cleanup}" method="post">
                            <input type="hidden" name="drop" value="1" />
                            <input type="hidden" name="form_token" value="{$form_token}" />
                            <input type="hidden" name="timestamp" value="{$timestamp}" />
                            <button type="submit" class="button" name="submit" value="{$lang_common['continue']}">{$button_array['continue']}{$lang_common['continue']}</button>
                        </form>
                    </td>
                </tr>
            </table>
EOT;
    }
}

?>
